/*-
 * Copyright (C)2014 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: recobe.h,v 1.1 2014/02/18 16:40:37 babolo Exp $
 */

#define RECOBE_CODEMAX 7
#define RECOBE_NOTABLE 0
#define RECOBE_TEXT    1
#define RECOBE_G711    2
#define RECOBE_MAX     3

typedef struct {
    u_int16_t cw;
    struct {
        u_char t;
        char   n;
        char  *s;
    } nm[RECOBE_CODEMAX];
    char   *p[RECOBE_MAX];
    u_char *ic[RECOBE_CODEMAX][RECOBE_CODEMAX];
} recobe_collection_t;

extern int16_t             recobe_deG711A[256];
extern int16_t             recobe_deG711u[256];
extern u_char              recobe_G711A2u[256];
extern u_char              recobe_G711u2A[256];
extern recobe_collection_t recobe_collection;

u_char recobe_G711A     __P((int16_t sample));
u_char recobe_G711u     __P((int16_t sample));
int    recobe_G711Atest __P((int fi, u_char *buf, size_t l));
int    recobe_G711utest __P((int fi, u_char *buf, size_t l));
